package com.company.jexample.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "NEW_ENTITY", indexes = {
        @Index(name = "IDX_NEW_ENTITY_LATEST_ENTITY2", columnList = "LATEST_ENTITY2_ID")
})
@Entity
public class NewEntity {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @InstanceName
    @Column(name = "NAME")
    private String name;

    @Composition
    @OneToMany(mappedBy = "newEntity")
    private List<NewEntity2> entiy2List;

    @JoinColumn(name = "LATEST_ENTITY2_ID")
    @Composition
    @OneToOne(fetch = FetchType.LAZY)
    private NewEntity2 latestEntity2;

    public NewEntity2 getLatestEntity2() {
        return latestEntity2;
    }

    public void setLatestEntity2(NewEntity2 latestEntity2) {
        this.latestEntity2 = latestEntity2;
    }

    public List<NewEntity2> getEntiy2List() {
        return entiy2List;
    }

    public void setEntiy2List(List<NewEntity2> entiy2List) {
        this.entiy2List = entiy2List;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}