package com.company.jexample.screen.newentity;

import com.company.jexample.entity.NewEntity2;
import io.jmix.ui.model.CollectionPropertyContainer;
import io.jmix.ui.screen.*;
import com.company.jexample.entity.NewEntity;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("NewEntity.edit")
@UiDescriptor("new-entity-edit.xml")
@EditedEntityContainer("newEntityDc")
public class NewEntityEdit extends StandardEditor<NewEntity> {
    @Autowired
    private CollectionPropertyContainer<NewEntity2> entiy2ListDc;

    @Subscribe
    public void onBeforeCommitChanges(BeforeCommitChangesEvent event) {
        if(!entiy2ListDc.getMutableItems().isEmpty()){
            // В реальном проекте здесь сортровка по дате и
            // подстановка самого свежего эксземпляра
            getEditedEntity().setLatestEntity2(entiy2ListDc.getMutableItems().get(0));
        }
    }
}